#! /usr/bin/env lua

-- Hello World

require("lgui")
require("ldraw")

function expose(widget)
	local cr = ldraw.Context.createFromDrawable(widget:getWindow())
	local width, height = widget:getSize()

	-- Rectangle
	cr:rectangle(0, 0, width, height)
	cr:setSourceRgba(1, 0, 0, 0.80)
	cr:fill()

	-- Line
	cr:setSourceRgb(0, 0, 1)
	cr:moveTo(0, 0)
	cr:lineTo(width, height)
	cr:moveTo(width, 0)
	cr:lineTo(0, height)
	cr:setLineWidth(20)
	cr:stroke()

	cr:destroy()
end

local window = lgui.Window.new()
window:set("title", "Drawing", "window-position", lgui.WIN_POS_CENTER,
"app-paintable", true)

window:connect("delete-event", lgui.quit)
window:connect("expose-event", expose, window)

window:showAll()
lgui.main()
