#! /usr/bin/env lua

-- Effects on a image, from http://zetcode.com/tutorials/cairographicstutorial/cairoimages/

require("lgui")
require("ldraw")

local window = lgui.Window.new()
local image  = ldraw.Surface.createFromPng("tux.png")
local stop = false
iWidth, iHeight, angle, w, h = 0, 0, 0, 0, 0

function expose(widget)
	local cr = ldraw.Context.createFromDrawable(widget:getWindow())
	local width, height = window:getSize()
	iWidth, iHeight = image:getSize()
  	w = iWidth
  	local surface = ldraw.Surface.create(ldraw.FORMAT_ARGB32, iWidth, iHeight)
  	local ic	  = ldraw.Context.create(surface)
  	ic:rectangle(0, 0, w, h)
  	ic:fill()

  	h = h + 1

  	if( h >= iHeight) then
  		stop = true
  		return false
  	end

  	cr:setSourceSurface(image, 10, 10)
  	cr:maskSurface(surface, 10, 10)
  	surface:destroy()
  	cr:destroy()
  	ic:destroy()

  	return false
end

function update(window)
	if stop then
		window:set("title", "Done!")
		return false
	end

	window:queueDraw()
	return true
end

window:set("title", "Loading!", "window-position", lgui.WIN_POS_CENTER,
"app-paintable", true)

window:connect("delete-event", lgui.quit)
window:connect("expose-event", expose, window)
lobj.Timeout.add(lobj.PRIORITY_DEFAULT_IDLE, 100, update, window)

window:showAll()
lgui.main()
